!---------------------------------------------
! One-way wave-equation shot-profile migration
!---------------------------------------------
! Author : Yaxun Tang
! Version: 2.0
! Date   : Jan. 1, 2008
program main
  use bwi_kernel_mod
  implicit none

  type(dat_grid) :: dgrid
  type(pro_grid) :: pgrid
  type(vel_grid) :: vgrid
  type(img_grid) :: igrid
  type(hes_grid) :: hgrid
  type(bwi_ftag) :: ftag_ 
  logical        :: adj, add 
  integer        :: stat

  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
  call sep_begin_prog()

  call from_param("add", add, .false.)

  stat = bwi_kernel_init(dgrid, pgrid, vgrid, igrid, hgrid, ftag_)

  if (pgrid%mode=="imgfwd" .or. pgrid%mode=="imgadj") then
     if (pgrid%mode=="imgfwd") adj = .false.
     if (pgrid%mode=="imgadj") adj = .true.

     stat = bwi_kerimg_oper(adj, add, ftag_%csou_, ftag_%crec_, ftag_%bvel_, ftag_%bimg_)

  else
     write(0,*)"ERROR: WRONG MODE"
     STOP
  end if

  write(0,*)"***********************"
  write(0,*)"      Finished!!!      "
  write(0,*)"***********************"

  call sep_end_prog()

  call exit()

end program
