#ifndef AXIS_H
#define AXIS_H 1
#include<iostream>
#include<string>


class axis{
  public:
    axis(){}  //Default constructor does nothing
    axis(int n, float o, float d, std::string label, std::string unit);
    axis(int n, float o, float d, std::string label);
    axis(int n, float o, float d);
    axis(int n);
    
    //assignment operator
    axis& operator = (const axis& ax_) {
      this->n = ax_.n;
      this->o = ax_.o;
      this->d = ax_.d;
      this->label = ax_.label;
      this->unit = ax_.unit;
      return *this;
    }
    
    void print_info(const string& sz){
      prt("AXIS %s, %d %f %f, label=%s, unit=%s \n",sz.c_str(),n,o,d,
          label.c_str(),unit.c_str());
     }
    
    bool same_axis(const axis& ax) const;
    int n;
    float o,d;
    std::string label,unit;
    
	void get_nod(int &in, float &io, float& id) {
	   in = n;
	   io = o; id = d;
	}
  ~axis(){}
  
   void scaleUnit(float fScale) {
	  this->o = this->o * fScale;
	  this->d = this->d * fScale; return;
   }
   
  float get_coord( int offset) const {
    assert(offset>=0 && offset<n);
	  return (d*(offset)+o); 
  }
  int   get_offset( float coord) const {
    int ret=int((coord-o)/d + 0.5f);
    assert(ret>=0 && ret<n);
    return ret;
  }
  float get_offsetf( float coord) const {  //get fractional offset
    float ret=(coord-o)/d;
    return ret;
  }
 
  void getRange(float* pMin, float* pMax) const {
    assert(this->d>0.0f);
    if (pMin) {
      *pMin = this->o;
    }
    if (pMax) {
      *pMax = this->o + (n-1)*d;
    }
  }   
   //Alter the length of axis, but not changing axis.d
   //For example truncation or elongation
   axis alter(int offsetBeg, int offsetEnd = -1) const {
     axis ax = *this;
     ax.o = this->get_coord(offsetBeg);
     if (offsetEnd==-1) {
       ax.n = this->n - offsetBeg;
     } else {
       ax.n = offsetEnd - offsetBeg + 1;
     }
     return ax;
   }
   
  private:
    void basic_set(int n, float o, float d, std::string label, std::string unit);
    
    };
	
	typedef std::vector<axis> vecAxis;
#endif



