#ifndef MODELING_OP_ONEWAY_H
#define MODELING_OP_ONEWAY_H 1


#include "gVec.h"
#include "op.h"
#include "hypercube.h"
#include "cubeData.hpp"
#include "cubeAlgo.h"
#include "dmRsf.hpp"
#include "modelingFD_aux.h"
#include "modelingOp.h"

namespace Yang {

class vel;
//Forward declaration of template class
//template <typename T>
//class dmRsf_oc;

struct OneWayParamTang;
class modelingOpOneway: public modelingOp  //Define the class of wave propagation operator
{
public:
   
public://methods
  modelingOpOneway():modelingOp() {}
  
  //init the operator using the wave propagation params. e.g. dtComp
  virtual void initOperator(FDModelingParams* params, action_type ac_type);
  virtual void initOperatorEx(FDModelingParams* params, action_type ac_type);
  virtual void modeling_op(cubeData<float>* pVelCube, dmRsf<float>* pRsfSeisRec);
  virtual void bornModeling_op(cubeData<float>* pReflCube, dmRsf<float>* pRsfSeisRec);
  virtual void migration_op(dmRsf<float>* pRsfSeisRec, cubeData<float>* pImageCube);
  virtual void migration_op(const string& seisTag, cubeData<float>* pImageCube);
  virtual void TomAdj_op (cubeData<float>* pDeltaIh, cubeData<float>* pDeltaS);
  virtual void TomFwd_op (cubeData<float>* pRsfSeisRec, cubeData<float>* pImageCube);
protected:
  void setOneWayParam(OneWayParamTang* par);
  void convertImage(cubeData<float> &ImageYaxun, cubeData<float>& myImgCube, bool bFromMyImageToYaxun);
  void convertVelModel(cubeData<float> &vmodYaxun, cubeData<float>& myVelCube, bool bFromMyvelToYaxunVel);
  void migration(OneWayParamTang& param, cubeData<float>* pImageCube);
};

} //end of namespace Yang

#endif

