#include "stdafx.h"
#include "cubeData.hpp"
#include "velFD2d.h"
#include "velAna.h"

// TODO: your implementation here
using namespace Yang;


void velAna_FD::loadDataObs() {
   m_pVelAnaParam-> dObsCube.init( &(m_pVelAnaParam->pDataObs->domain()) );
   m_pVelAnaParam-> pDataObs->seq_grabAll( & m_pVelAnaParam->dObsCube);
}

void velAna_FD::setVelocity(const cubeData<float> * pVelCube) {
   m_FDModelingParam->pVel->setVelocity(*pVelCube);
}

void velAna::setMoveoutDeriv(cubeData<float>& cube, tagMoveOutType tp)
{
   axis ax= cube.domain().get_axis(1);
   VERIFY(cube.domain().get_ndim()==1);
   int n = ax.n;
   float o = ax.o;
   float d = ax.d;
   float x;
   
   if (tp == tangentSquare) {
      VERIFY( fabs(o) < 90);
      VERIFY( fabs(o+(n-1)*d) < 90);
   }
   for(int i=0;i<n;i++)
   {
	  x = o + i*d;
	  if (tp == Quadratic) 
		 cube[i] = x*x;
	  else if (tp == Linear)
		 cube[i] = x;
	  else if (tp == tangentSquare)
     cube[i] = SQ(tanf(x/180.0f*PI));
    else if (tp == constant)
     cube[i] = 1.0f; 
    else {
       prt("\nWrong MoveoutType in beamFocus func");
       abort();
    }
   }
   return;
}

